#pragma once

#include <Qt>
#include <QWidget>
#include <QKeyEvent>

namespace BGTU::ComputerGraphicsLabWork::Lab1 {
	class KeyboardCatcherWidget : public QWidget {
	Q_OBJECT
	public:
		inline KeyboardCatcherWidget(QWidget *parent = nullptr) : QWidget{parent} {
			this->grabKeyboard();
		}

	signals:

		void key_pressed_PageUp();

		void key_pressed_PageDown();

		void key_pressed_G();

		void key_pressed_1();

		void key_pressed_2();

		void key_pressed_3();

		void key_pressed_4();

		void key_pressed_5();

		void key_pressed_6();

		void key_pressed_7();

		void key_pressed_8();

		void key_pressed_9();

		void key_pressed_0();

	protected:
		void keyPressEvent(QKeyEvent *event) override {
			switch (event->key()) {
				case Qt::Key_PageUp:
					emit this->key_pressed_PageUp();
					return;
				case Qt::Key_PageDown:
					emit this->key_pressed_PageDown();
					return;
				case Qt::Key_G:
					emit this->key_pressed_G();
					return;
				case Qt::Key_1:
					emit this->key_pressed_1();
					return;
				case Qt::Key_2:
					emit this->key_pressed_2();
					return;
				case Qt::Key_3:
					emit this->key_pressed_3();
					return;
				case Qt::Key_4:
					emit this->key_pressed_4();
					return;
				case Qt::Key_5:
					emit this->key_pressed_5();
					return;
				case Qt::Key_6:
					emit this->key_pressed_6();
					return;
				case Qt::Key_7:
					emit this->key_pressed_7();
					return;
				case Qt::Key_8:
					emit this->key_pressed_8();
					return;
				case Qt::Key_9:
					emit this->key_pressed_9();
					return;
				case Qt::Key_0:
					emit this->key_pressed_0();
					return;
			}

		}
	};
}